function GR=IGVGramComputation(A,N,nmin,nmax,eta,sigma,order)

%% (c) 2004 Marco Cuturi , marco.cuturi@ensmp.fr
%% Distributed under GPL licence

% This function computes a GramMatrix of IGV kernel evaluations
% on images contained in A, where:
% A : a matrix of images
% N : amount of points to take into account in the matrix
% nmin , nmax : minimal and maximal sample size (amount of pixels) taken in
% each image
% eta : regularization parameter
% sigma : Gaussian kernel width, 0 value means linear kernel.


[n,dummy]=size(A);

if (N>n) 
    N=n;
end
B=matsample(A(1:N,:),nmin,nmax);
GR=zeros(N,N);
norm=zeros(1,N);

fix(clock)

for j=1:N
    GR(j,j)=IGVKernel(B(j,:),B(j,:),eta,sigma,order,0);
end;
for j=1:N
    j
    for i=j+1:N
        GR(i,j)=exp(.5*(GR(j,j)+GR(i,i))-IGVKernel(B(i,:),B(j,:),eta,sigma,order,0));
        GR(j,i)=GR(i,j);
    end;
end;
for j=1:N
    GR(j,j)=1;
end;

fix(clock)