function T=imdisplay(u,v,w,V,sigma,us)

%% (c) 2004 Marco Cuturi , marco.cuturi@ensmp.fr
%% Distributed under GPL licence


%%%%% This function displays clouds of points
%%%%% shown in u and v with respective weights
%%%%% and the eigenfunction determined by V.

T=zeros(u(2),2);
for j=1:u(2),
    T(j,2)=((u(2+j)-1)-mod((u(2+j)-1),28))/28+1;
    T(j,1)=u(2+j)-28*(T(j,2)-1);
    T(j,2)=28-T(j,2);
end;
S=zeros(v(2),2);
for j=1:v(2),
    S(j,2)=((v(2+j)-1)-mod((v(2+j)-1),28))/28+1;
    S(j,1)=v(2+j)-28*(S(j,2)-1);
    S(j,2)=28-S(j,2);
end;
[n,m]=size(w);
W=zeros(m,2);

for j=1:m,
    W(j,2)=((w(j)-1)-mod((w(j)-1),28))/28+1;
    W(j,1)=w(j)-28*(W(j,2)-1);
    W(j,2)=28-W(j,2);
end;

Ss=2*sigma^2*27^2;
hold on;
axis([0 28 0 28]);

Z='0';
%%%% Computing the middle point of the measure
M=us*W;
%%%% Creating the considered eigenfunction
for j=1:m,
    if (sigma>0) 
        Z=[ Z, '+ (' , num2str(V(j)) , ')*exp(-((x-(', num2str(W(j,1)), ') )^2 + (y-(', num2str(W(j,2)), ') )^2)/' , num2str(Ss), ')' ];
    else
        Z=[ Z, '+ (' , num2str(V(j)) , ')*(x*(', num2str(W(j,1)), ') + y*(', num2str(W(j,2)), '))/27^2'];
    end;
end;
%%%% Plotting the eigenfunction
ezcontourf(Z,[0,28,0,28]);

%%%% Weight factor between points of u and v
r=v(2)/u(2);
if r==0
    r=1;
end;

%%%% Plotting points.
plot(S(:,1),S(:,2),'o','MarkerSize',10,'MarkerFaceColor',[1 .2 .2]);
if (u(2)~=v(2)) | (~all(u==v))
        plot(T(:,1),T(:,2),'p','MarkerSize',10*r,'MarkerFaceColor',[.1 .9 .9]);
end;
plot(M(1,1),M(1,2),'*','MarkerSize',15,'MarkerFaceColor',[.2 .2 1]);

hold off;
